Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2528)
@@ -16,8 +16,13 @@
    !!   trd_mld_trc_init : initialization step
    !!----------------------------------------------------------------------
-   USE trp_trc           ! tracer definitions (trn, trb, tra, etc.)
-   USE oce_trc           ! needed for namelist logicals, and euphotic layer arrays
-   USE trctrp_lec
-   USE trdmld_trc_oce    ! definition of main arrays used for trends computations
+   USE trc               ! tracer definitions (trn, trb, tra, etc.)
+   USE dom_oce           ! domain definition
+   USE zdfmxl  , ONLY : nmln !: number of level in the mixed layer
+   USE zdf_oce , ONLY : avt  !: vert. diffusivity coef. at w-point for temp  
+# if defined key_zdfddm   
+   USE zdfddm  , ONLY : avs  !: salinity vertical diffusivity coeff. at w-point
+# endif
+   USE trcnam_trp      ! passive tracers transport namelist variables
+   USE trdmod_trc_oce    ! definition of main arrays used for trends computations
    USE in_out_manager    ! I/O manager
    USE dianam            ! build the name of file (routine)
@@ -29,17 +34,13 @@
    USE sms_pisces        
    USE sms_lobster
-   USE trc
 
    IMPLICIT NONE
    PRIVATE
 
-   INTERFACE trd_mod_trc
-      MODULE PROCEDURE trd_mod_trc_trp, trd_mod_trc_bio
-   END INTERFACE
-
-   PUBLIC trd_mod_trc                                             ! routine called by step.F90
    PUBLIC trd_mld_trc
    PUBLIC trd_mld_bio
    PUBLIC trd_mld_trc_init
+   PUBLIC trd_mld_trc_zint
+   PUBLIC trd_mld_bio_zint
 
    CHARACTER (LEN=40) ::  clhstnam                                ! name of the trends NetCDF file
@@ -60,78 +61,10 @@
 #  include "top_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   TOP 1.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Header:  $ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
-
-   SUBROUTINE trd_mod_trc_trp( ptrtrd, kjn, ktrd, kt )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE trd_mod_trc  ***
-      !!----------------------------------------------------------------------
-#if defined key_trcbbl_adv
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zun, zvn                   ! temporary arrays
-#else
-      USE oce_trc,   zun => un                                            ! When no bbl, zun == un
-      USE oce_trc,   zvn => vn                                            ! When no bbl, zvn == vn
-#endif
-      INTEGER, INTENT( in )  ::   kt                                  ! time step
-      INTEGER, INTENT( in )  ::   kjn                                 ! tracer index
-      INTEGER, INTENT( in )  ::   ktrd                                ! tracer trend index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout )  ::   ptrtrd  ! Temperature or U trend
-      !!----------------------------------------------------------------------
-
-      IF( kt == nittrc000 ) THEN
-!         IF(lwp)WRITE(numout,*)
-!         IF(lwp)WRITE(numout,*) 'trd_mod_trc:'
-!         IF(lwp)WRITE(numout,*) '~~~~~~~~~~~~'
-      ENDIF
-
-      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-      ! Mixed layer trends for passive tracers
-      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-
-      SELECT CASE ( ktrd )
-         CASE ( jptrc_trd_xad     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_xad    , '3D', kjn )
-         CASE ( jptrc_trd_yad     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_yad    , '3D', kjn )
-         CASE ( jptrc_trd_zad     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_zad    , '3D', kjn )
-         CASE ( jptrc_trd_ldf     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_ldf    , '3D', kjn )
-         CASE ( jptrc_trd_xei     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_xei    , '3D', kjn )
-         CASE ( jptrc_trd_yei     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_yei    , '3D', kjn )
-         CASE ( jptrc_trd_bbl     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_bbl    , '3D', kjn )
-         CASE ( jptrc_trd_zdf     )
-            IF( ln_trcldf_iso ) THEN
-               CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_ldf, '3D', kjn )
-            ELSE
-               CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_zdf, '3D', kjn )
-            ENDIF
-         CASE ( jptrc_trd_zei     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_zei    , '3D', kjn )
-         CASE ( jptrc_trd_dmp     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_dmp    , '3D', kjn )
-         CASE ( jptrc_trd_sbc     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_sbc    , '2D', kjn )
-         CASE ( jptrc_trd_sms     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_sms    , '3D', kjn )
-         CASE ( jptrc_trd_bbc     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_bbc    , '3D', kjn )
-         CASE ( jptrc_trd_radb    )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_radb   , '3D', kjn )
-         CASE ( jptrc_trd_radn    )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_radn   , '3D', kjn )
-         CASE ( jptrc_trd_atf     )   ;   CALL trd_mld_trc_zint( ptrtrd, jpmld_trc_atf    , '3D', kjn )
-      END SELECT
-
-
-   END SUBROUTINE trd_mod_trc_trp
-
-   SUBROUTINE trd_mod_trc_bio( ptrbio, ktrd, kt )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE trd_mod_bio  ***
-      !!----------------------------------------------------------------------
-
-      INTEGER, INTENT( in )  ::   kt                                  ! time step
-      INTEGER, INTENT( in )  ::   ktrd                                ! bio trend index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout )  ::   ptrbio  ! Bio trend
-      !!----------------------------------------------------------------------
-
-      CALL trd_mld_bio_zint( ptrbio, ktrd ) ! Verticaly integrated biological trends
-
-   END SUBROUTINE trd_mod_trc_bio
-
 
    SUBROUTINE trd_mld_trc_zint( ptrc_trdmld, ktrd, ctype, kjn )
@@ -170,5 +103,5 @@
           
          ! ... Set nmld(ji,jj) = index of first T point below control surf. or outside mixed-layer
-         SELECT CASE ( nctls_trc )                                ! choice of the control surface
+         SELECT CASE ( nn_ctls_trc )                                ! choice of the control surface
             CASE ( -2  )   ;   STOP 'trdmld_trc : not ready '     !     -> isopycnal surface (see ???)
 #if defined key_pisces || defined key_lobster
@@ -177,6 +110,6 @@
             CASE (  0  )   ;   nmld_trc(:,:) = nmln(:,:)          !     -> ML with density criterion (see zdfmxl)
             CASE (  1  )   ;   nmld_trc(:,:) = nbol_trc(:,:)          !     -> read index from file
-            CASE (  2: )   ;   nctls_trc = MIN( nctls_trc, jpktrd_trc - 1 )
-                               nmld_trc(:,:) = nctls_trc + 1      !     -> model level
+            CASE (  2: )   ;   nn_ctls_trc = MIN( nn_ctls_trc, jpktrd_trc - 1 )
+                               nmld_trc(:,:) = nn_ctls_trc + 1      !     -> model level
          END SELECT
 
@@ -281,11 +214,11 @@
          tmltrd_bio(:,:,:) = 0.e0    ! <<< reset trend arrays to zero
          ! ... Set nmld(ji,jj) = index of first T point below control surf. or outside mixed-layer
-         SELECT CASE ( nctls_trc )                                    ! choice of the control surface
+         SELECT CASE ( nn_ctls_trc )                                    ! choice of the control surface
             CASE ( -2  )   ;   STOP 'trdmld_trc : not ready '     !     -> isopycnal surface (see ???)
             CASE ( -1  )   ;   nmld_trc(:,:) = neln(:,:)          !     -> euphotic layer with light criterion
             CASE (  0  )   ;   nmld_trc(:,:) = nmln(:,:)          !     -> ML with density criterion (see zdfmxl)
             CASE (  1  )   ;   nmld_trc(:,:) = nbol_trc(:,:)          !     -> read index from file
-            CASE (  2: )   ;   nctls_trc = MIN( nctls_trc, jpktrd_trc - 1 )
-                               nmld_trc(:,:) = nctls_trc + 1          !     -> model level
+            CASE (  2: )   ;   nn_ctls_trc = MIN( nn_ctls_trc, jpktrd_trc - 1 )
+                               nmld_trc(:,:) = nn_ctls_trc + 1          !     -> model level
          END SELECT
 
@@ -380,5 +313,5 @@
       !!        of time-averaged mixed-layer fields, this residual WILL NOT BE ZERO
       !!        over the first two analysis windows (except if restart).
-      !!        N.B. For ORCA2_LIM, use e.g. ntrc_trc=5, ucf_trc=1., nctls_trc=8
+      !!        N.B. For ORCA2_LIM, use e.g. ntrc_trc=5, rn_ucf_trc=1., nctls_trc=8
       !!             for checking residuals.
       !!             On a NEC-SX5 computer, this typically leads to:
@@ -421,5 +354,4 @@
       REAL(wp), DIMENSION(jpi,jpj,jpltrd_trc,jptra) ::  ztmltrd2  ! -+
       !!
-      REAL(wp), DIMENSION(jpi,jpj) ::   z2d                       ! temporary array, used for eiv arrays
       CHARACTER (LEN= 5) ::   clvar
 #if defined key_dimgout
@@ -429,12 +361,5 @@
       !!----------------------------------------------------------------------
 
-      IF( llwarn ) THEN                                           ! warnings
-         IF(      ( nittrc000 /= nit000   ) &
-              .OR.( ndttrc    /= 1        )    ) THEN
-
-            WRITE(numout,*) 'Be careful, trends diags never validated'
-            STOP 'Uncomment this line to proceed'
-         ENDIF
-      ENDIF
+      IF( nn_dttrc  /= 1  ) CALL ctl_stop( " Be careful, trends diags never validated " )
 
       ! ======================================================================
@@ -450,7 +375,7 @@
             DO ji = 1,jpi
                ik = nmld_trc(ji,jj)
-               zavt = avt(ji,jj,ik)
+               zavt = fsavs(ji,jj,ik)
                DO jn = 1, jptra
-                  IF( luttrd(jn) )    &
+                  IF( ln_trdtrc(jn) )    &
                   tmltrd_trc(ji,jj,jpmld_trc_zdf,jn) = - zavt / fse3w(ji,jj,ik) * tmask(ji,jj,ik)  &
                        &                    * ( trn(ji,jj,ik-1,jn) - trn(ji,jj,ik,jn) )            &
@@ -462,5 +387,5 @@
          DO jn = 1, jptra
          ! ... Remove this K_z trend from the iso-neutral diffusion term (if any)
-            IF( luttrd(jn) ) &
+            IF( ln_trdtrc(jn) ) &
                  tmltrd_trc(:,:,jpmld_trc_ldf,jn) = tmltrd_trc(:,:,jpmld_trc_ldf,jn) - tmltrd_trc(:,:,jpmld_trc_zdf,jn)
    
@@ -473,5 +398,5 @@
       ! therefore we do not call lbc_lnk in GYRE config. (closed basin, no cyclic B.C.)
       DO jn = 1, jptra
-         IF( luttrd(jn) ) THEN
+         IF( ln_trdtrc(jn) ) THEN
             DO jl = 1, jpltrd_trc
                CALL lbc_lnk( tmltrd_trc(:,:,jl,jn), 'T', 1. )        ! lateral boundary conditions
@@ -490,7 +415,7 @@
       ! II.1 Set before values of vertically averages passive tracers
       ! -------------------------------------------------------------
-      IF( kt > nittrc000 ) THEN
+      IF( kt > nit000 ) THEN
          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN
+            IF( ln_trdtrc(jn) ) THEN
                tmlb_trc   (:,:,jn) = tml_trc   (:,:,jn)
                tmlatfn_trc(:,:,jn) = tmltrd_trc(:,:,jpmld_trc_atf,jn)
@@ -505,5 +430,5 @@
       DO jk = 1, jpktrd_trc ! - 1 ???
          DO jn = 1, jptra
-            IF( luttrd(jn) ) &
+            IF( ln_trdtrc(jn) ) &
                tml_trc(:,:,jn) = tml_trc(:,:,jn) + wkx_trc(:,:,jk) * trn(:,:,jk,jn)
          END DO
@@ -515,5 +440,5 @@
          !
          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN
+            IF( ln_trdtrc(jn) ) THEN
                tmlbb_trc  (:,:,jn) = tmlb_trc   (:,:,jn)   ;   tmlbn_trc  (:,:,jn) = tml_trc    (:,:,jn)
                tmlatfb_trc(:,:,jn) = tmlatfn_trc(:,:,jn)   ;   tmlradb_trc(:,:,jn) = tmlradn_trc(:,:,jn)
@@ -544,5 +469,5 @@
          ! ... Cumulate over BOTH physical contributions AND over time steps
          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN
+            IF( ln_trdtrc(jn) ) THEN
                DO jl = 1, jpltrd_trc
                   tmltrdm_trc(:,:,jn) = tmltrdm_trc(:,:,jn) + tmltrd_trc(:,:,jl,jn)
@@ -552,5 +477,5 @@
 
          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN
+            IF( ln_trdtrc(jn) ) THEN
                ! ... Special handling of the Asselin trend 
                tmlatfm_trc(:,:,jn) = tmlatfm_trc(:,:,jn) + tmlatfn_trc(:,:,jn)
@@ -573,10 +498,10 @@
 
       ! Convert to appropriate physical units
-      tmltrd_trc(:,:,:,:) = tmltrd_trc(:,:,:,:) * ucf_trc
-
-      itmod = kt - nittrc000 + 1
+      tmltrd_trc(:,:,:,:) = tmltrd_trc(:,:,:,:) * rn_ucf_trc
+
+      itmod = kt - nit000 + 1
       it    = kt
 
-      MODULO_NTRD : IF( MOD( itmod, ntrd_trc ) == 0 ) THEN           ! nitend MUST be multiple of ntrd_trc
+      MODULO_NTRD : IF( MOD( itmod, nn_trd_trc ) == 0 ) THEN           ! nitend MUST be multiple of nn_trd_trc
          !
          ztmltot (:,:,:) = 0.e0                                   ! reset arrays to zero
@@ -591,7 +516,7 @@
 
          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN
+            IF( ln_trdtrc(jn) ) THEN
                !-- Compute total trends    (use rdttrc instead of rdt ???)
-               IF ( ln_trcadv_smolar .OR. ln_trcadv_muscl .OR. ln_trcadv_muscl2 ) THEN  ! EULER-FORWARD schemes
+               IF ( ln_trcadv_muscl .OR. ln_trcadv_muscl2 ) THEN  ! EULER-FORWARD schemes
                   ztmltot(:,:,jn) =  ( tml_trc(:,:,jn) - tmlbn_trc(:,:,jn) )/rdt
                ELSE                                                                     ! LEAP-FROG schemes
@@ -629,5 +554,5 @@
                !-- Compute passive tracer total trends
          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN
+            IF( ln_trdtrc(jn) ) THEN
                tml_sum_trc(:,:,jn) = tmlbn_trc(:,:,jn) + 2 * ( tml_sum_trc(:,:,jn) - tml_trc(:,:,jn) ) + tml_trc(:,:,jn)
                ztmltot2   (:,:,jn) = ( tml_sum_trc(:,:,jn) - tml_sumb_trc(:,:,jn) ) /  ( 2.*rdt )    ! now tracer unit is /sec
@@ -637,5 +562,5 @@
          !-- Compute passive tracer residuals
          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN
+            IF( ln_trdtrc(jn) ) THEN
                !
                DO jl = 1, jpltrd_trc
@@ -680,5 +605,5 @@
             DO jn = 1, jptra
 
-               IF( luttrd(jn) ) THEN
+               IF( ln_trdtrc(jn) ) THEN
                   WRITE(numout, *)
                   WRITE(numout, *) '>>>>>>>>>>>>>>>>>>  TRC TRACER jn =', jn, ' <<<<<<<<<<<<<<<<<<'
@@ -777,5 +702,5 @@
          rmld_sum_trc(:,:)     = rmld_sum_trc(:,:)     /      (2*zfn)  ! similar to tml_sum and sml_sum
          DO jn = 1, jptra
-            IF( luttrd(jn) ) THEN        
+            IF( ln_trdtrc(jn) ) THEN        
                ! For passive tracer instantaneous diagnostics
                tmlbb_trc  (:,:,jn) = tmlb_trc   (:,:,jn)   ;   tmlbn_trc  (:,:,jn) = tml_trc    (:,:,jn)
@@ -791,14 +716,14 @@
                ! III.4 Convert to appropriate physical units
                ! -------------------------------------------
-               ztmltot     (:,:,jn)   = ztmltot     (:,:,jn)   * ucf_trc/zfn   ! instant diags
-               ztmlres     (:,:,jn)   = ztmlres     (:,:,jn)   * ucf_trc/zfn
-               ztmlatf     (:,:,jn)   = ztmlatf     (:,:,jn)   * ucf_trc/zfn
-               ztmlrad     (:,:,jn)   = ztmlrad     (:,:,jn)   * ucf_trc/zfn
+               ztmltot     (:,:,jn)   = ztmltot     (:,:,jn)   * rn_ucf_trc/zfn   ! instant diags
+               ztmlres     (:,:,jn)   = ztmlres     (:,:,jn)   * rn_ucf_trc/zfn
+               ztmlatf     (:,:,jn)   = ztmlatf     (:,:,jn)   * rn_ucf_trc/zfn
+               ztmlrad     (:,:,jn)   = ztmlrad     (:,:,jn)   * rn_ucf_trc/zfn
                tml_sum_trc (:,:,jn)   = tml_sum_trc (:,:,jn)   /      (2*zfn)  ! mean diags
-               ztmltot2    (:,:,jn)   = ztmltot2    (:,:,jn)   * ucf_trc/zfn2
-               ztmltrd2    (:,:,:,jn) = ztmltrd2    (:,:,:,jn) * ucf_trc/zfn2
-               ztmlatf2    (:,:,jn)   = ztmlatf2    (:,:,jn)   * ucf_trc/zfn2
-               ztmlrad2    (:,:,jn)   = ztmlrad2    (:,:,jn)   * ucf_trc/zfn2
-               ztmlres2    (:,:,jn)   = ztmlres2    (:,:,jn)   * ucf_trc/zfn2
+               ztmltot2    (:,:,jn)   = ztmltot2    (:,:,jn)   * rn_ucf_trc/zfn2
+               ztmltrd2    (:,:,:,jn) = ztmltrd2    (:,:,:,jn) * rn_ucf_trc/zfn2
+               ztmlatf2    (:,:,jn)   = ztmlatf2    (:,:,jn)   * rn_ucf_trc/zfn2
+               ztmlrad2    (:,:,jn)   = ztmlrad2    (:,:,jn)   * rn_ucf_trc/zfn2
+               ztmlres2    (:,:,jn)   = ztmlres2    (:,:,jn)   * rn_ucf_trc/zfn2
             ENDIF
          END DO
@@ -820,5 +745,5 @@
       ! ----------------------------------
 
-      IF( lwp .AND. MOD( itmod , ntrd_trc ) == 0 ) THEN
+      IF( lwp .AND. MOD( itmod , nn_trd_trc ) == 0 ) THEN
          WRITE(numout,*) ' '
          WRITE(numout,*) 'trd_mld_trc : write passive tracer trends in the NetCDF file :'
@@ -834,16 +759,5 @@
          DO jn = 1, jptra
             !
-            IF( luttrd(jn) ) THEN
-               !-- Specific treatment for EIV trends
-               !   WARNING : When eiv is switched on but key_diaeiv is not, we do NOT diagnose
-               !   u_eiv, v_eiv, and w_eiv : the exact eiv advective trends thus cannot be computed,
-               !   only their sum makes sense => mask directional contrib. to avoid confusion
-               z2d(:,:) = tmltrd_trc(:,:,jpmld_trc_xei,jn) + tmltrd_trc(:,:,jpmld_trc_yei,jn) &
-                    &   + tmltrd_trc(:,:,jpmld_trc_zei,jn)
-#if ( defined key_trcldf_eiv && defined key_diaeiv )
-               tmltrd_trc(:,:,jpmld_trc_xei,jn) = -999.
-               tmltrd_trc(:,:,jpmld_trc_yei,jn) = -999.
-               tmltrd_trc(:,:,jpmld_trc_zei,jn) = -999.
-#endif   
+            IF( ln_trdtrc(jn) ) THEN
                CALL histwrite( nidtrd(jn), "mxl_depth", it, rmld_trc(:,:), ndimtrd1, ndextrd1 )
                !-- Output the fields
@@ -864,7 +778,4 @@
                     &          it, ztmlatf(:,:,jn), ndimtrd1, ndextrd1 )
                      
-               CALL histwrite( nidtrd(jn), trim(clvar//ctrd_trc( jpltrd_trc+1,2)),     &  ! now total EIV : jpltrd_trc + 1
-                    &          it, z2d(:,:), ndimtrd1, ndextrd1 )                     
-            !
             ENDIF
          END DO
@@ -872,5 +783,5 @@
          IF( kt == nitend ) THEN 
             DO jn = 1, jptra
-               IF( luttrd(jn) )  CALL histclo( nidtrd(jn) )
+               IF( ln_trdtrc(jn) )  CALL histclo( nidtrd(jn) )
             END DO
          ENDIF
@@ -881,15 +792,5 @@
          DO jn = 1, jptra
             !
-            IF( luttrd(jn) ) THEN
-               !-- Specific treatment for EIV trends
-               !   WARNING : see above
-               z2d(:,:) = ztmltrd2(:,:,jpmld_trc_xei,jn) + ztmltrd2(:,:,jpmld_trc_yei,jn) &
-                   &   + ztmltrd2(:,:,jpmld_trc_zei,jn)
-
-#if ( defined key_trcldf_eiv && defined key_diaeiv )
-               ztmltrd2(:,:,jpmld_trc_xei,jn) = -999.
-               ztmltrd2(:,:,jpmld_trc_yei,jn) = -999.
-               ztmltrd2(:,:,jpmld_trc_zei,jn) = -999.
-#endif
+            IF( ln_trdtrc(jn) ) THEN
                CALL histwrite( nidtrd(jn), "mxl_depth", it, rmld_sum_trc(:,:), ndimtrd1, ndextrd1 ) 
                !-- Output the fields
@@ -911,7 +812,4 @@
                  &          it, ztmlatf2(:,:,jn), ndimtrd1, ndextrd1 )
 
-               CALL histwrite( nidtrd(jn), trim(clvar//ctrd_trc( jpltrd_trc+1,2)),    &  ! now total EIV : jpltrd_trc + 1
-                 &          it, z2d(:,:), ndimtrd1, ndextrd1 )
-
             ENDIF 
             !
@@ -919,5 +817,5 @@
          IF( kt == nitend ) THEN 
             DO jn = 1, jptra
-               IF( luttrd(jn) )  CALL histclo( nidtrd(jn) )
+               IF( ln_trdtrc(jn) )  CALL histclo( nidtrd(jn) )
             END DO
          ENDIF
@@ -931,5 +829,5 @@
 # endif /* key_dimgout */
 
-      IF( MOD( itmod, ntrd_trc ) == 0 ) THEN
+      IF( MOD( itmod, nn_trd_trc ) == 0 ) THEN
          !
          ! Reset cumulative arrays to zero
@@ -1010,12 +908,5 @@
       !!----------------------------------------------------------------------
       ! ... Warnings
-      IF( llwarn ) THEN
-         IF(      ( nittrc000 /= nit000   ) &
-              .OR.( ndttrc    /= 1        )    ) THEN
-
-            WRITE(numout,*) 'Be careful, trends diags never validated'
-            STOP 'Uncomment this line to proceed'
-         END IF
-      END IF
+      IF( nn_dttrc  /= 1  ) CALL ctl_stop( " Be careful, trends diags never validated " )
 
       ! ======================================================================
@@ -1058,7 +949,7 @@
 
       ! Convert to appropriate physical units
-      tmltrd_bio(:,:,:) = tmltrd_bio(:,:,:) * ucf_trc
-
-      MODULO_NTRD : IF( MOD( kt, ntrd_trc ) == 0 ) THEN      ! nitend MUST be multiple of ntrd
+      tmltrd_bio(:,:,:) = tmltrd_bio(:,:,:) * rn_ucf_trc
+
+      MODULO_NTRD : IF( MOD( kt, nn_trd_trc ) == 0 ) THEN      ! nitend MUST be multiple of ntrd
          !
          zfn  = float(nmoymltrdbio)    ;    zfn2 = zfn * zfn
@@ -1114,5 +1005,5 @@
          ! III.4 Convert to appropriate physical units
          ! -------------------------------------------
-         ztmltrdbio2    (:,:,:) = ztmltrdbio2    (:,:,:) * ucf_trc/zfn2
+         ztmltrdbio2    (:,:,:) = ztmltrdbio2    (:,:,:) * rn_ucf_trc/zfn2
 
       END IF MODULO_NTRD
@@ -1133,8 +1024,8 @@
 
       ! define time axis
-      itmod = kt - nittrc000 + 1
+      itmod = kt - nit000 + 1
       it    = kt
 
-      IF( lwp .AND. MOD( itmod , ntrd_trc ) == 0 ) THEN
+      IF( lwp .AND. MOD( itmod , nn_trd_trc ) == 0 ) THEN
          WRITE(numout,*) ' '
          WRITE(numout,*) 'trd_mld_bio : write ML bio trends in the NetCDF file :'
@@ -1176,5 +1067,5 @@
 # endif /* key_dimgout */
 
-      IF( MOD( itmod, ntrd_trc ) == 0 ) THEN
+      IF( MOD( itmod, nn_trd_trc ) == 0 ) THEN
          !
          ! III.5 Reset cumulative arrays to zero
@@ -1216,12 +1107,9 @@
       INTEGER :: ilseq, jl, jn
       REAL(wp) ::   zjulian, zsto, zout
-      CHARACTER (LEN=40) ::   clop, cleiv
+      CHARACTER (LEN=40) ::   clop
       CHARACTER (LEN=15) ::   csuff
       CHARACTER (LEN=12) ::   clmxl
       CHARACTER (LEN=16) ::   cltrcu
       CHARACTER (LEN= 5) ::   clvar
-
-      NAMELIST/namtoptrd/ ntrd_trc, nctls_trc, ucf_trc, &
-                          ln_trdmld_trc_restart, ln_trdmld_trc_instant, luttrd
 
       !!----------------------------------------------------------------------
@@ -1241,24 +1129,10 @@
       ! I.1 Check consistency of user defined preferences
       ! -------------------------------------------------
-#if defined key_trcldf_eiv
-      IF( lk_trdmld_trc .AND. ln_trcldf_iso ) THEN
-         WRITE(numout,cform_war)
-         WRITE(numout,*) '                You asked for ML diagnostics with iso-neutral diffusion   '
-         WRITE(numout,*) '                and eiv physics.                                          '
-         WRITE(numout,*) '                Yet, key_diaeiv is NOT switched on, so the eddy induced   '
-         WRITE(numout,*) '                velocity is not diagnosed.                                '
-         WRITE(numout,*) '                Therefore, we cannot deduce the eiv advective trends.     '
-         WRITE(numout,*) '                Only THE SUM of the i,j,k directional contributions then  '
-         WRITE(numout,*) '                makes sense => To avoid any confusion, we choosed to mask '
-         WRITE(numout,*) '                these i,j,k directional contributions (with -999.)        '
-         nwarn = nwarn + 1
-      ENDIF
-#  endif
-
-      IF( ( lk_trdmld_trc ) .AND. ( MOD( nitend, ntrd_trc ) /= 0 ) ) THEN
+
+      IF( ( lk_trdmld_trc ) .AND. ( MOD( nitend, nn_trd_trc ) /= 0 ) ) THEN
          WRITE(numout,cform_err)
          WRITE(numout,*) '                Your nitend parameter, nitend = ', nitend
          WRITE(numout,*) '                is no multiple of the trends diagnostics frequency        '
-         WRITE(numout,*) '                          you defined, ntrd_trc   = ', ntrd_trc
+         WRITE(numout,*) '                          you defined, nn_trd_trc   = ', nn_trd_trc
          WRITE(numout,*) '                This will not allow you to restart from this simulation.  '
          WRITE(numout,*) '                You should reconsider this choice.                        ' 
@@ -1269,29 +1143,8 @@
       ENDIF
 
-      IF( ( lk_trdmld_trc ) .AND. ( n_cla == 1 ) ) THEN
-         WRITE(numout,cform_war)
-         WRITE(numout,*) '                You set n_cla = 1. Note that the Mixed-Layer diagnostics  '
-         WRITE(numout,*) '                are not exact along the corresponding straits.            '
-         nwarn = nwarn + 1
-      ENDIF
-
-
       ! * Debugging information *
       IF( lldebug ) THEN
          WRITE(numout,*) '               ln_trcadv_muscl = '      , ln_trcadv_muscl
-         WRITE(numout,*) '               ln_trcadv_smolar = '     , ln_trcadv_smolar
          WRITE(numout,*) '               ln_trdmld_trc_instant = ', ln_trdmld_trc_instant
-      ENDIF
-
-      IF( ln_trcadv_smolar .AND. .NOT. ln_trdmld_trc_instant ) THEN
-         WRITE(numout,cform_err)
-         WRITE(numout,*) '                Currently, you can NOT use simultaneously tracer Smolark. '
-         WRITE(numout,*) '                advection and window averaged diagnostics of ML trends.   '
-         WRITE(numout,*) '                WHY? Everything in trdmld_trc is coded for leap-frog, and '
-         WRITE(numout,*) '                Smolarkiewicz scheme is Euler forward.                    '
-         WRITE(numout,*) '                In particuliar, entrainment trend would be FALSE. However '
-         WRITE(numout,*) '                this residual is correct for instantaneous ML diagnostics.'
-         WRITE(numout,*) 
-         nstop = nstop + 1
       ENDIF
 
@@ -1364,5 +1217,5 @@
       ! I.3 Read control surface from file ctlsurf_idx
       ! ----------------------------------------------
-      IF( nctls_trc == 1 ) THEN
+      IF( nn_ctls_trc == 1 ) THEN
          CALL ctl_opn( inum, 'ctlsurf_idx', 'OLD', 'UNFORMATTED', 'SEQUENTIAL', -1, numout, lwp )
          READ ( inum ) nbol_trc
@@ -1378,10 +1231,10 @@
 #else
       ! clmxl = legend root for netCDF output
-      IF( nctls_trc == 0 ) THEN                                   ! control surface = mixed-layer with density criterion
+      IF( nn_ctls_trc == 0 ) THEN                                   ! control surface = mixed-layer with density criterion
          clmxl = 'Mixed Layer '
-      ELSE IF( nctls_trc == 1 ) THEN                              ! control surface = read index from file 
+      ELSE IF( nn_ctls_trc == 1 ) THEN                              ! control surface = read index from file 
          clmxl = '      Bowl '
-      ELSE IF( nctls_trc >= 2 ) THEN                              ! control surface = model level
-         WRITE(clmxl,'(A10,I2,1X)') 'Levels 1 -', nctls_trc
+      ELSE IF( nn_ctls_trc >= 2 ) THEN                              ! control surface = model level
+         WRITE(clmxl,'(A10,I2,1X)') 'Levels 1 -', nn_ctls_trc
       ENDIF
 
@@ -1395,5 +1248,5 @@
          STOP 'trd_mld_trc : this was never checked. Comment this line to proceed...'
       ENDIF
-      zsto = ntrd_trc * rdt
+      zsto = nn_trd_trc * rdt
       clop = "inst("//TRIM(clop)//")"
 #  else
@@ -1401,9 +1254,9 @@
          zsto = rdt                                               ! inst. diags : we use IOIPSL time averaging
       ELSE
-         zsto = ntrd_trc * rdt                                    ! mean  diags : we DO NOT use any IOIPSL time averaging
+         zsto = nn_trd_trc * rdt                                    ! mean  diags : we DO NOT use any IOIPSL time averaging
       ENDIF
       clop = "ave("//TRIM(clop)//")"
 #  endif
-      zout = ntrd_trc * rdt
+      zout = nn_trd_trc * rdt
 
       IF(lwp) WRITE (numout,*) '                netCDF initialization'
@@ -1424,9 +1277,4 @@
       !       ==> choose them according to trdmld_trc_oce.F90 <==
 
-#if defined key_diaeiv
-      cleiv = " (*** only total EIV is meaningful ***)"           ! eiv advec. trends require u_eiv, v_eiv
-#else
-      cleiv = " "
-#endif
       ctrd_trc(jpmld_trc_xad    ,1) = " Zonal advection"                 ;   ctrd_trc(jpmld_trc_xad    ,2) = "_xad"
       ctrd_trc(jpmld_trc_yad    ,1) = " Meridional advection"            ;   ctrd_trc(jpmld_trc_yad    ,2) = "_yad"
@@ -1434,8 +1282,4 @@
       ctrd_trc(jpmld_trc_ldf    ,1) = " Lateral diffusion"               ;   ctrd_trc(jpmld_trc_ldf    ,2) = "_ldf"
       ctrd_trc(jpmld_trc_zdf    ,1) = " Vertical diff. (Kz)"             ;   ctrd_trc(jpmld_trc_zdf    ,2) = "_zdf"
-      ctrd_trc(jpmld_trc_xei    ,1) = " Zonal EIV advection"//cleiv      ;   ctrd_trc(jpmld_trc_xei    ,2) = "_xei"
-      ctrd_trc(jpmld_trc_yei    ,1) = " Merid. EIV advection"//cleiv     ;   ctrd_trc(jpmld_trc_yei    ,2) = "_yei"
-      ctrd_trc(jpmld_trc_zei    ,1) = " Vertical EIV advection"//cleiv   ;   ctrd_trc(jpmld_trc_zei    ,2) = "_zei"
-      ctrd_trc(jpmld_trc_bbc    ,1) = " Geothermal flux"                 ;   ctrd_trc(jpmld_trc_bbc    ,2) = "_bbc"
       ctrd_trc(jpmld_trc_bbl    ,1) = " Adv/diff. Bottom boundary layer" ;   ctrd_trc(jpmld_trc_bbl    ,2) = "_bbl"
       ctrd_trc(jpmld_trc_dmp    ,1) = " Tracer damping"                  ;   ctrd_trc(jpmld_trc_dmp    ,2) = "_dmp"
@@ -1445,13 +1289,12 @@
       ctrd_trc(jpmld_trc_radn   ,1) = " Correct negative concentrations" ;   ctrd_trc(jpmld_trc_radn   ,2) = "_radn"
       ctrd_trc(jpmld_trc_atf    ,1) = " Asselin time filter"             ;   ctrd_trc(jpmld_trc_atf    ,2) = "_atf"
-      ctrd_trc(jpltrd_trc+1     ,1) = " Total EIV"//cleiv                ;   ctrd_trc(jpltrd_trc+1     ,2) = "_tei"
 
       DO jn = 1, jptra      
       !-- Create a NetCDF file and enter the define mode 
-         IF( luttrd(jn) ) THEN
+         IF( ln_trdtrc(jn) ) THEN
             csuff="ML_"//ctrcnm(jn)
-            CALL dia_nam( clhstnam, ntrd_trc, csuff )
+            CALL dia_nam( clhstnam, nn_trd_trc, csuff )
             CALL histbeg( clhstnam, jpi, glamt, jpj, gphit,                                            &
-               &        1, jpi, 1, jpj, nittrc000-ndttrc, zjulian, rdt, nh_t(jn), nidtrd(jn), domain_id=nidom )
+               &        1, jpi, 1, jpj, nit000, zjulian, rdt, nh_t(jn), nidtrd(jn), domain_id=nidom, snc4chunks=snc4set )
       
             !-- Define the ML depth variable
